#pragma once
#include <messagebasic.h>
#include "componentbasic.h"

class COMPONENTBASIC_EXPORT ComponentsInfoPull : public ProcList<
	WsRespond<ComponentInfosQuery, ComponentInfoQueryResult>
> {
private:
	std::weak_ptr<WsEntity> _bind_entity;

public:
	ComponentsInfoPull();

	// ͨ ProcList ̳
	void bindEntity(std::weak_ptr<WsEntity> ins) override;
	QString name() const override;

	void execute(std::shared_ptr<Immediate> map, std::shared_ptr<const ComponentInfosQuery> in, QList<std::shared_ptr<ComponentInfoQueryResult>>& out) override;

	std::shared_ptr<WsComponent> defaultNew() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};