#pragma once

#include "simsbasic_global.h"
#include <QJsonObject>
#include <memory>
#include <functional>

/// <summary>
/// л
/// </summary>
class Serializable {
public:
	virtual ~Serializable() = default;
	/// <summary>
	/// ͨлȫָ
	/// </summary>
	/// <param name="obj">Json</param>
	virtual void recoveryFrom(const QJsonObject& obj) = 0;
	/// <summary>
	/// ͨл
	/// </summary>
	/// <param name="obj">ĿJson</param>
	virtual void saveTo(QJsonObject& obj) const = 0;
};

/// <summary>
/// 쳣
/// </summary>
class SIMSBASIC_EXPORT UniException {
private:
	QString _error_store;

public:
	explicit UniException(const QString& msg);
	virtual ~UniException() = default;

	virtual QString content() const noexcept;
};

/// <summary>
/// ͨϢ
/// </summary>
class WsMessage : public Serializable {
public:
	virtual ~WsMessage() = default;
	/// <summary>
	/// ȡϢַ
	/// </summary>
	/// <returns>Ϣ</returns>
	virtual QString topicString() const = 0;
	/// <summary>
	/// ĿʵID
	/// </summary>
	/// <returns>ID</returns>
	virtual uint64_t targetEntity() const = 0;
	/// <summary>
	/// ԴʵID
	/// </summary>
	/// <returns>ID</returns>
	virtual uint64_t sourceEntity() const = 0;
};

/// <summary>
/// Respondǩ
/// </summary>
using WsRespondSignatureType = std::pair<QString, QString>;

/// <summary>
/// ʵִ
/// </summary>
class Immediate {
public:
	virtual ~Immediate() = default;
	/// <summary>
	/// ȡʵid
	/// </summary>
	/// <returns></returns>
	virtual uint64_t entityManagerID() const = 0;
	/// <summary>
	/// ʵָ͵ĵִ
	/// </summary>
	/// <param name="in"></param>
	/// <returns></returns>
	virtual QList<std::shared_ptr<WsMessage>> execute(const WsRespondSignatureType& resp_signature, std::shared_ptr<const WsMessage> in) = 0;
	/// <summary>
	/// ʵڼݵִ
	/// </summary>
	/// <param name="in"></param>
	/// <returns></returns>
	virtual QList<std::shared_ptr<WsMessage>> execute(std::shared_ptr<const WsMessage> in) = 0;
};

/// <summary>
/// ϢԪͨýӿ
/// </summary>
using WsRespondEntry = std::function<void(std::shared_ptr<Immediate> map, std::shared_ptr<const WsMessage>, QList<std::shared_ptr<WsMessage>>&)>;

/// <summary>
/// ʵӿ
/// </summary>
class WsEntity : public Serializable {
public:
	virtual ~WsEntity() = default;

	/// <summary>
	/// ȡʵģ
	/// </summary>
	/// <returns>ģ</returns>
	virtual QString templetName() const = 0;

	/// <summary>
	/// ȡʵID
	/// </summary>
	/// <returns></returns>
	virtual uint64_t entityID() const = 0;
	/// <summary>
	/// ȡʵ
	/// </summary>
	/// <returns></returns>
	virtual QString name() const = 0;

	/// <summary>
	/// ȿ¡ʵһ
	/// </summary>
	/// <returns></returns>
	virtual std::shared_ptr<WsEntity> defaultNew() const = 0;

	/// <summary>
	/// ָͨǩȡ
	/// </summary>
	/// <param name="t">ǩ</param>
	/// <returns>ӿ</returns>
	virtual QList<WsRespondEntry> getEntryWithSignature(const WsRespondSignatureType& t) const = 0;
	/// <summary>
	/// ͨϢͻȡ
	/// </summary>
	/// <param name="msg_type">Ϣ</param>
	/// <returns>ӿб</returns>
	virtual QList<WsRespondEntry> getEntryWithInType(const QString& msg_type) const = 0;
};

/// <summary>
/// ܲĻ
/// </summary>
class WsComponent : public Serializable, public std::enable_shared_from_this<WsComponent> {
public:
	virtual ~WsComponent() = default;

	/// <summary>
	/// ¡һͬݵʵ
	/// </summary>
	/// <returns>ʵָ</returns>
	virtual std::shared_ptr<WsComponent> defaultNew() const = 0;
	/// <summary>
	/// Entity
	/// </summary>
	/// <param name="entity_id">ʵʵ</param>
	virtual void bindEntity(std::weak_ptr<WsEntity> host) = 0;

	/// <summary>
	/// Ψһ
	/// </summary>
	/// <returns></returns>
	virtual QString name() const = 0;

	/// <summary>
	/// Ϣ
	/// </summary>
	/// <returns>Ϣͼ</returns>
	virtual QList<QString> inputTypes() const = 0;
	/// <summary>
	/// ָͨǩȡ
	/// </summary>
	/// <param name="t">ǩ</param>
	/// <returns>ӿ</returns>
	virtual QList<WsRespondEntry> getEntryWithSignature(const WsRespondSignatureType& t) const = 0;
	/// <summary>
	/// ͨϢͻȡ
	/// </summary>
	/// <param name="msg_type">Ϣ</param>
	/// <returns>ӿб</returns>
	virtual QList<WsRespondEntry> getEntrysWithInType(const QString& msg_type) const = 0;
};

/// <summary>
/// ӿ
/// </summary>
class ComponentSet {
public:
	/// <summary>
	/// Ϊʵָ͵Ĳ
	/// </summary>
	/// <param name="ins"></param>
	virtual void append(std::shared_ptr<WsComponent> ins) = 0;
	/// <summary>
	/// Ƴָ͵Ĳʵ
	/// </summary>
	/// <param name="component_type"></param>
	virtual void remove(const QString& component_type) = 0;
	/// <summary>
	/// ȡʵڰвʵ
	/// </summary>
	/// <returns></returns>
	virtual QList<std::shared_ptr<WsComponent>> components() const = 0;
};
